/* This file is part of `mogul'
 * Copyright (c) 1995 David Deaven
 *
 * In the following, "you" and "You" refer to any entity other than 
 * the Microsoft corporation and its subsidiaries.  All rights are
 * reserved by the author in connection with Microsoft and its
 * subsidiaries.  The Microsoft Network is explicity denied the right
 * to copy, reproduce, or transmit this software.
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Author: deaven $
 * $Id: camera.h,v 2.0 1996/07/09 20:59:55 deaven Exp $
 */

#ifndef _DMD_CAMERA_H_
#define _DMD_CAMERA_H_

typedef struct CameraRec *Camera;

Camera NewCamera(void);
void DeleteCamera(Camera c);
Camera CameraCopy(Camera src, Camera dst);
Camera CameraSetPosition(Camera c, double x[3]);
Camera CameraSetView(Camera c, double x[3]);
Camera CameraSetUp(Camera c, double x[3]);
Camera CameraSet(Camera c, double x[3], double v[3], double up[3]);
double *CameraGetPosition(Camera c, double x[3]);
double *CameraGetView(Camera c, double x[3]);
double *CameraGetUp(Camera c, double x[3]);
double *CameraGetTransform(Camera c, double t[4 * 4]);
Camera CameraPan(Camera c, double dx, double dy, double dz);
Camera CameraMoveOnGlassSphere(Camera c,
  double x1, double y1, double x0, double y0, double radius, Camera reference);
int CameraWasUpdated(Camera c);

#endif /* _DMD_CAMERA_H_ */
